unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls,LCD;


Const
    SX_PIXEL=4; //6-Pixel width
    SY_PIXEL=7; //9-Pixel heigth
    NB_PIXEL_X=12;  //Number of pixel in X
    NB_PIXEL_Y=5;   //Number of pixel in Y
    NB_PIXEL_X_WEEK=3;  //Number of pixel in X for week
    NB_PIXEL_Y_WEEK=5;  //Number of pixel in Y for week
//    POS_GT10 = 28;  //Position of the string GT10 in the wristapp
    CHKPATTERN = 'GT12';

type
  TColLcd = Array [0..11] of byte;

  TFrmMain = class(TForm)
    Panel4: TPanel;
    PnMO: TPanel;
    PnTU: TPanel;
    PnWE: TPanel;
    PnTH: TPanel;
    PnFR: TPanel;
    PnSA: TPanel;
    PnSU: TPanel;
    BtWrite: TBitBtn;
    BtQuit: TBitBtn;
    Panel6: TPanel;
    Memo1: TMemo;
    IMMainLcd: TImage;
    IMSu: TImage;
    IMMo: TImage;
    IMTu: TImage;
    IMWe: TImage;
    IMTh: TImage;
    IMFr: TImage;
    IMSa: TImage;
    LbFound: TLabel;
    SBSetWristappLoc: TSpeedButton;
    OpenDialog: TOpenDialog;
    Memo2: TMemo;
    LbPos: TLabel;
    SBCopy: TSpeedButton;
    SBPaste: TSpeedButton;
    SBUShift: TSpeedButton;
    SBDShift: TSpeedButton;
    SBRShift: TSpeedButton;
    SBLShift: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    SBDRotate: TSpeedButton;
    SBLRotate: TSpeedButton;
    SBURotate: TSpeedButton;
    SBRRotate: TSpeedButton;
    SaveDialog: TSaveDialog;
    Panel1: TPanel;
    ChkShowYear: TCheckBox;
    Panel2: TPanel;
    IMWeek: TImage;
    ChkShowWeek: TCheckBox;
    Panel3: TPanel;
    BtLoad: TButton;
    BtSave: TButton;
    procedure FormShow(Sender: TObject);
    procedure BtWriteClick(Sender: TObject);
    procedure BtQuitClick(Sender: TObject);
    procedure SBSetWristappLocClick(Sender: TObject);
    procedure WristappPresent;
    procedure FormCreate(Sender: TObject);
    procedure ReadWristapp;
    procedure IMMainLcdMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure IMMainLcdMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PnSelClick(Sender: TObject);
    procedure SBPasteClick(Sender: TObject);
    procedure SBCopyClick(Sender: TObject);
    procedure ClipToLCD(lcd:TLcd);
    procedure LCDToClip(lcd:TLcd);
    procedure SBLShiftClick(Sender: TObject);
    procedure SBRShiftClick(Sender: TObject);
    procedure SBUShiftClick(Sender: TObject);
    procedure SBDShiftClick(Sender: TObject);
    procedure SBLRotateClick(Sender: TObject);
    procedure SBRRotateClick(Sender: TObject);
    procedure SBURotateClick(Sender: TObject);
    procedure SBDRotateClick(Sender: TObject);
    procedure BtSaveClick(Sender: TObject);
    function  GetLCDCol(lcd:TLcd;col:integer):Integer;
    procedure SetColLCD(lcd:TLcd; col,value:integer);
    procedure BtLoadClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure IMWeekMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { Private declarations }
    Function Recherche(fichier,s:string):integer;
  public
    { Public declarations }
    PatternName, fname : string;
    present : boolean;
    Tab : Array [1..30] of TColLCD;
    Clip : TColLCD;
    LCDWeek : TLCD;
    MainLcd :TLcd;
    MainMem1:TLcd;
    MainMem2:TLcd;
    MainMem3:TLcd;
    MainMem4:TLcd;
    MainMem5:TLcd;
    MainMem6:TLcd;
    MainMem7:TLcd;

    PnSel:Integer;
    Modified:Boolean;
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}

{
Function TestWristapp(filename,s:string;p:integer):boolean;
var f : file of byte;
    b : byte;
    i : integer;
    ok :boolean;
begin
  TestWristapp:=false;
  {//$I-}
{
  if FileExists(fileName) then begin
    assignfile(f,filename);
    reset(f);
    try
      seek(f,p);
      ok:=true;
      for i:=1 to length(s) do
      begin
        read(f,b);
        if chr(b)<>s[i] then ok:=false;
      end;
      TestWristapp:=ok;
    finally
      CloseFile(f);
    end;
  end;
}
  {//$I+}
//end;


procedure TFrmMain.ReadWristapp;
var f : file of byte;
    b : byte;
    i,p : Integer;
    s : string;
begin
  p:=Recherche(fname,CHKPATTERN);
  if p<>0 then //TestWristapp(fname,'GT10',POS_GT10) then
  begin
    {$I-}
    assignfile(f,fname);
    reset(f);
    try
      seek(f,P+4-1);

      //-- Read Sunday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem1,i,b);
      End;

      //-- Read Monday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem2,i,b);
      End;

      //-- Read Tuesday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem3,i,b);
      End;

      //-- Read Wednesday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem4,i,b);
      End;

      //-- Read Thursday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem5,i,b);
      End;

      //-- Read Friday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem6,i,b);
      End;

      //-- Read Saturday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem7,i,b);
      End;

      Read(f,b);
      ChkShowYear.Checked:=((b and 1)<>0);
      ChkShowWeek.Checked:=((b and 2)<>0);

      //-- Read Week --
      For i:=0 to 2 do
      Begin
        read(f,b);
        SetColLCD(LCDWeek,i,b);
      End;

      MainMem1.Display;
      MainMem2.Display;
      MainMem3.Display;
      MainMem4.Display;
      MainMem5.Display;
      MainMem6.Display;
      MainMem7.Display;
      LCDWeek.Display;

      PnSel:=1;
      PnSelClick(PnSU);
    finally
      closefile(f);
    end;
    {$I+}
  end
  else MessageDlg('Enable to open the wristapp or wrong file.', mtError, [mbOK], 0);
end;


procedure TFrmMain.FormShow(Sender: TObject);
begin
  WristappPresent;
  ReadWristapp;
end;


procedure TFrmMain.BtWriteClick(Sender: TObject);
var f : file of byte;
    b1, b2 : byte;
    x,p : Integer;
    s : string;
begin
  if not present then begin
    beep;
    exit;
  end;
  p:=Recherche(fname,CHKPATTERN);
  if p<>0 then //TestWristapp(fname,'GT10',POS_GT10) then
  begin
    assignfile(f,fname);
    {$I-}
    reset(f);
    try
      seek(f,P+4-1);

      //-- Write Sunday --
      For x:=0 to 11 do
      Begin
        b1:=GetLCDCol(MainMem1,x);
        Write(f,b1);
      End;

      //-- Write Monday --
      For x:=0 to 11 do
      Begin
        b1:=GetLCDCol(MainMem2,x);
        Write(f,b1);
      End;

      //-- Write Tuesday --
      For x:=0 to 11 do
      Begin
        b1:=GetLCDCol(MainMem3,x);
        Write(f,b1);
      End;

      //-- Write Wednesday --
      For x:=0 to 11 do
      Begin
        b1:=GetLCDCol(MainMem4,x);
        Write(f,b1);
      End;

      //-- Write Thursday --
      For x:=0 to 11 do
      Begin
        b1:=GetLCDCol(MainMem5,x);
        Write(f,b1);
      End;

      //-- Write Friday --
      For x:=0 to 11 do
      Begin
        b1:=GetLCDCol(MainMem6,x);
        Write(f,b1);
      End;

      //-- Write Saturday --
      For x:=0 to 11 do
      Begin
        b1:=GetLCDCol(MainMem7,x);
        Write(f,b1);
      End;

      if ChkShowYear.Checked
        then b1:=1
        else b1:=0;
      if ChkShowWeek.Checked
        then b1:=b1 or 2;
      Write(f,b1);

      //-- Write Week --
      For x:=0 to 2 do
      Begin
        b1:=GetLCDCol(LCDWeek,x);
        Write(f,b1);
      End;

    Finally
      closefile(f);
    End;
    {$I+}
  end
  else MessageDlg('Enable to open the wristapp or wrong file', mtError, [mbOK], 0);
End;


procedure TFrmMain.BtQuitClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmMain.SBSetWristappLocClick(Sender: TObject);
begin
  OpenDialog.FileName:=fname;
  OpenDialog.DefaultExt:='bin';
  OpenDialog.Filter:='bin file (*.bin)|*.bin|all file (*.*)|*.*';
  Opendialog.Execute;
  WristappPresent;
  if present then ReadWristapp;
end;

procedure TFrmMain.WristappPresent;
Var P:Integer;
Begin
  P:=Recherche(OpenDialog.FileName,CHKPATTERN);
  if P<>0 then begin
    LbFound.Caption:='Wristapp found : YES';
    fname:=OpenDialog.Filename;
    present:=true;
  end
  else begin
    LbFound.Caption:='Wristapp found : NO';
    present:=false;
  end;
End;

procedure TFrmMain.FormCreate(Sender: TObject);
begin
  fname:='C:\Program Files\Timex\Data Link USB\App\daytodg_code_018.bin';
  OpenDialog.FileName:=fname;
  PatternName:='';

  MainLCD:=TLcd.Create(Self);
  MainMem1:=TLcd.Create(Self);
  MainMem2:=TLcd.Create(Self);
  MainMem3:=TLcd.Create(Self);
  MainMem4:=TLcd.Create(Self);
  MainMem5:=TLcd.Create(Self);
  MainMem6:=TLcd.Create(Self);
  MainMem7:=TLcd.Create(Self);
  LCDWeek:=TLcd.Create(Self);

  MainLCD.SetParam(@IMMainLcd,SX_PIXEL*2,SY_PIXEL*2,NB_PIXEL_X,NB_PIXEL_Y);
  MainMem1.SetParam(@IMSu, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  MainMem2.SetParam(@IMMo, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  MainMem3.SetParam(@IMTu, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  MainMem4.SetParam(@IMWe, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  MainMem5.SetParam(@IMTh, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  MainMem6.SetParam(@IMFr, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  MainMem7.SetParam(@IMSa, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  LCDWeek.SetParam(@IMWeek, SX_PIXEL*2, SY_PIXEL*2,NB_PIXEL_X_WEEK, NB_PIXEL_Y_WEEK);

  PnSel:=1;
  PnSelClick(PnSU);
  present:=False;
  modified:=False;
end;


procedure TFrmMain.IMMainLcdMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MainLcd.InvPixel(x,y);
  MainLcd.Display;
  Modified:=True;
end;


procedure TFrmMain.FormDestroy(Sender: TObject);
begin
  MainLCD.Free;
  MainMem1.Free;
  MainMem2.Free;
  MainMem3.Free;
  MainMem4.Free;
  MainMem5.Free;
  MainMem6.Free;
  MainMem7.Free;
end;


procedure TFrmMain.IMMainLcdMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var  tx,ty:integer;
begin
  tx:=MainLCD.GetPositionX(X);
  ty:=MainLCD.GetPositionY(Y);
  LbPos.Caption:=Format('X=%2d  Y=%2d',[tx, ty]);
end;


procedure TFrmMain.PnSelClick(Sender: TObject);
begin
  PnSU.color:=clBlack;
  PnMO.color:=clBlack;
  PnTU.color:=clBlack;
  PnWE.color:=clBlack;
  PnTH.color:=clBlack;
  PnFR.color:=clBlack;
  PnSA.color:=clBlack;
  TPanel(Sender).color:=clGreen; //clMoneyGreen;

  if Sender=PnSU then
  Begin
    PnSel:=1;
    MainMem1.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem1);
  End
  else if Sender=PnMO then
  Begin
    PnSel:=2;
    MainMem2.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem2);
  End
  else if Sender=PnTU then
  Begin
    PnSel:=3;
    MainMem3.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem3);
  End
  else if Sender=PnWE then
  Begin
    PnSel:=4;
    MainMem4.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem4);
  End
  else if Sender=PnTH then
  Begin
    PnSel:=5;
    MainMem5.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem5);
  End
  else if Sender=PnFR then
  Begin
    PnSel:=6;
    MainMem6.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem6);
  End
  else if Sender=PnSA then
  Begin
    PnSel:=7;
    MainMem7.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem7);
  End;
end;


procedure TFrmMain.ClipToLCD(lcd:TLcd);
Var x,y:integer;
    v,w:Byte;
Begin
  For x:=0 to 11 do
  Begin
    v:=Clip[x];
    w:=1;
    For y:=0 to 4 do
    Begin
      if (v and w)<>0 then lcd.DirectSetPixel(x,y,True)
      else lcd.DirectSetPixel(x,y,False);
      w:=w*2;
    End;
  End;
End;


procedure TFrmMain.LCDToClip(lcd:TLcd);
Var x,y:integer;
    v,w:Byte;
Begin
  For x:=0 to 11 do
  Begin
    v:=0;
    w:=1;
    For y:=0 to 4 do
    Begin
      if lcd.DirectGetPixel(x,y) then v:=v+w;
      w:=w*2;
    End;
    Clip[x]:=v;
  End;
End;


procedure TFrmMain.SBPasteClick(Sender: TObject);
begin
  ClipToLCD(MainLCD);
  ClipToLCD(MainLCD.GetLink^);
  (MainLCD.GetLink^).Display;
  MainLCD.Display;
  Modified:=True;
end;


procedure TFrmMain.SBCopyClick(Sender: TObject);
begin
  LCDToClip(MainLCD);
end;


procedure TFrmMain.SBLShiftClick(Sender: TObject);
begin
  MainLCD.ShiftLeft(false);
  Modified:=True;
end;


procedure TFrmMain.SBRShiftClick(Sender: TObject);
begin
  MainLCD.ShiftRight(false);
  Modified:=True;
end;


procedure TFrmMain.SBUShiftClick(Sender: TObject);
begin
  MainLCD.ShiftUp(false);
  Modified:=True;
end;


procedure TFrmMain.SBDShiftClick(Sender: TObject);
begin
  MainLCD.ShiftDown(false);
  Modified:=True;
end;


procedure TFrmMain.SBLRotateClick(Sender: TObject);
begin
  MainLCD.ShiftLeft(true);
  Modified:=True;
end;


procedure TFrmMain.SBRRotateClick(Sender: TObject);
begin
  MainLCD.ShiftRight(true);
  Modified:=True;
end;


procedure TFrmMain.SBURotateClick(Sender: TObject);
begin
  MainLCD.ShiftUp(true);
  Modified:=True;
end;


procedure TFrmMain.SBDRotateClick(Sender: TObject);
begin
  MainLCD.ShiftDown(true);
  Modified:=True;
end;


procedure TFrmMain.BtSaveClick(Sender: TObject);
Var x,y:integer;
    v,w:Byte;
    s:String;
    f:textfile;
begin
  SaveDialog.FileName:=PatternName;
  If SaveDialog.Execute then Begin
    PatternName:=SaveDialog.Filename;
    Assignfile(f,PatternName);
    {$I-}
    Rewrite(f);
    if IOResult <>0 then
    begin
      MessageDlg('Enable to create "' + PatternName +'"',
        mtInformation, [mbOk], 0);
      CloseFile(f);
    end
    else Begin
      Writeln(f,'GDW2');
      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem1,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem2,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem3,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem4,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem5,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem6,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem7,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 2 do
      Begin
        s:=s+IntToHex(GetLCDCol(LCDWeek,x),2);
      End;
      Writeln(f,s);

      CloseFile(f);
      Modified:=False;
    End;
    {$I+}
  End;
end;


function TFrmMain.GetLCDCol(lcd:TLcd;col:integer):Integer;
Var y:integer;
    v,w:Byte;
Begin
  v:=0;
  w:=1;
  For y:=0 to 4 do
  Begin
    if lcd.DirectGetPixel(col,y) then v:=v+w;
    w:=w*2;
  End;
  GetLCDCol:=v;
End;


procedure TFrmMain.SetColLCD(lcd:TLcd; col,value:integer);
Var x,y:integer;
    w:Byte;
Begin
  w:=1;
  For y:=0 to 4 do
  Begin
    if (value and w)<>0 then lcd.DirectSetPixel(col,y,True)
    else lcd.DirectSetPixel(col,y,False);
    w:=w*2;
  End;
End;



procedure TFrmMain.BtLoadClick(Sender: TObject);
Var x,y,version:integer;
    v,w:Byte;
    s,s1:String;
    f:textfile;
begin
  OpenDialog.FileName:=PatternName;
  OpenDialog.DefaultExt:='gdw';
  OpenDialog.Filter:='Config file (*.gdw)|*.gdw|all file (*.*)|*.*';
  If OpenDialog.Execute then Begin
    PatternName:=OpenDialog.Filename;
    Assignfile(f,PatternName);
    {$I-}
    Reset(f);
    if IOResult <>0 then
    begin
      MessageDlg('Enable to open "' + PatternName +'"',
        mtInformation, [mbOk], 0);
      CloseFile(f);
    end
    else Begin
      Version:=1;
      ReadLn(f,s);
      If s='GDW2' then Version:=2;

      If Version=2 then ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem1,x,strtointdef('$'+s1, 0));
      End;
      MainMem1.Display;

      ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem2,x,strtointdef('$'+s1, 0));
      End;
      MainMem2.Display;

      ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem3,x,strtointdef('$'+s1, 0));
      End;
      MainMem3.Display;

      ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem4,x,strtointdef('$'+s1, 0));
      End;
      MainMem4.Display;

      ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem5,x,strtointdef('$'+s1, 0));
      End;
      MainMem5.Display;

      ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem6,x,strtointdef('$'+s1, 0));
      End;
      MainMem6.Display;

      ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem7,x,strtointdef('$'+s1, 0));
      End;
      MainMem7.Display;

      If Version=2 then begin
        ReadLn(f,s);
        For x:=0 to 2 do
        Begin
          s1:=copy(s,x*2+1,2);
          SetColLCD(LCDWeek,x,strtointdef('$'+s1, 0));
        End;
        LCDWeek.Display;
      End;
      
      CloseFile(f);

      PnSel:=1;
      PnSelClick(PnSU);
      Modified:=False;
    End;
    {$I+}
  End;
end;


Function TFrmMain.Recherche(fichier,s:string):integer;
Var f:Textfile;
    c,p,l:Integer;
    b:char;
Begin
  l:=Length(s);
  c:=1;P:=0;
  Recherche:=0;
  If not FileExists(fichier) then exit;
  Assignfile(f,fichier);
  Reset(f);
  while (not eof(f) and (c<l+1)) do begin
    inc(p);
    read(f,b);
    if B=s[c]
      then C:=C+1
      else C:=1;
  End;
  closefile(f);
  if C=l+1
    then Recherche:=P-l+1
    else Recherche:=0;
End;


procedure TFrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=False;
  If Modified then begin
    If MessageDlg('Patterns not saved !'+#13+#10+'Continue ?', mtConfirmation, [mbNo,mbYes], 0)=mrYes Then CanClose:=True;
  end
  Else CanClose:=True;;
end;

procedure TFrmMain.IMWeekMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  LCDWeek.InvPixel(x,y);
  LCDWeek.Display;
  Modified:=True;
end;

end.
